VirtualBox

source: vbox/trunk/configure@ 5713

Last change on this file since 5713 was 5536, checked in by vboxsync, 17 years ago

Don't use the hacked path with all the bin/amd64 stuff and removed :: when writing env.sh on solaris.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 37.4 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 innotek GmbH
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26#
27# Defaults
28#
29OSE=1
30ODIR="`pwd`/"
31SETUP_WINE=
32TARGET_MACHINE=""
33TARGET_CPU=""
34WITH_XPCOM=1
35WITH_LIBIDL=1
36WITH_QT=1
37WITH_SDL=1
38WITH_SDL_TTF=1
39WITH_X11=1
40CC="gcc"
41CC32=""
42CC64=""
43CXX="g++"
44CXX32=""
45CXX64=""
46BCC="bcc"
47YASM="yasm"
48IASL="iasl"
49AS86="as86"
50XSLTPROC="xsltproc"
51GENISOIMAGE="genisoimage"
52MKISOFS="mkisofs"
53INCXALAN="/usr/local/include"
54LIBXALAN="-lxalan-c"
55LIBXALAN_DIR="/usr/local/lib"
56INCXERCES="/usr/local/include"
57LIBXERCES="-lxerces-c"
58LIBXERCES_DIR="/usr/local/lib"
59LIBCRYPTO="-lcrypto"
60LIBPTHREAD="-lpthread"
61LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
62INCX11="/usr/local/include"
63LIBXCURSOR="-lXcursor"
64INCZ=""
65LIBZ="-lz"
66INCPNG=""
67LIBPNG="-lpng"
68QTDIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3 /usr/lib64/qt-3.3 /usr/X11R6"
69KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
70DEVDIR="`cd \`dirname $0\`; pwd`/tools"
71if [ -d "/lib/modules/`uname -r`/build" ]; then
72 LINUX="/lib/modules/`uname -r`/build"
73else
74 LINUX="/usr/src/linux"
75fi
76KCHMVIEWER="kchmviewer"
77LOG="configure.log"
78CNF="AutoConfig.kmk"
79ENV="env.sh"
80BUILD_TYPE="release"
81# the restricting tool is ar (mri mode).
82INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
83
84if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
85 echo "Error: VBox base path contains invalid characters!"
86 exit 1
87fi
88
89cleanup()
90{
91 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
92}
93
94fail()
95{
96 if [ -z "$nofatal" -o "x$1" != "x" ]; then
97 cleanup
98 rm -f $ENV
99 exit 1
100 fi
101}
102
103log_success()
104{
105 if [ -n "$1" ]; then echo -n "$1, "; fi
106 echo "OK."
107 echo "$1" >> $LOG
108 echo >> $LOG
109 echo >> $LOG
110}
111
112log_failure()
113{
114 echo
115 echo " ** $1!"
116 echo "** $1!" >> $LOG
117 echo >> $LOG
118}
119
120cnf_append()
121{
122 printf "%-30s := %s\n" "$1" "$2" >> $CNF
123}
124
125strip_l()
126{
127 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|-[^l]\([^ ]\+\)||g; s|^ ||; s| *$||g'
128}
129
130strip_L()
131{
132 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|-[^L]\([^ ]\+\)||g; s|^ ||; s| *$||g'
133}
134
135strip_I()
136{
137 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|-[^I]\([^ ]\+\)||g; s|^ ||; s| *$||g'
138}
139
140prefix_I()
141{
142 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
143}
144
145# Wrapper for ancient /usr/bin/which on darwin that always returns 0
146which_wrapper()
147{
148 if [ -z "$have_ancient_which" ]; then
149 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
150 have_ancient_which="yes"
151 else
152 have_ancient_which="no"
153 fi
154 fi
155 if [ "$have_ancient_which" = "yes" ]; then
156 retval=`which $* 2>/dev/null`
157 echo "$retval"
158 test -n "$retval" -a -e "$retval"
159 unset retval
160 else
161 which $* 2> /dev/null
162 fi
163}
164
165check_avail()
166{
167 if [ -z "$1" ]; then
168 log_failure "$2 is empty"
169 fail $3
170 return 1
171 elif which_wrapper $1 > /dev/null; then
172 return 0
173 else
174 log_failure "$1 (variable $2) not found"
175 fail $3
176 return 1
177 fi
178}
179
180# Prepare a test
181test_header()
182{
183 echo "***** Checking $1 *****" >> $LOG
184 echo -n "Checking for $1: "
185}
186
187# Compile a test
188test_compile()
189{
190 echo "compiling the following source file:" >> $LOG
191 cat .tmp_src.cc >> $LOG
192 echo "using the following command line:" >> $LOG
193 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
194 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
195 if [ $? -ne 0 ]; then
196 if [ -z "$4" ]; then
197 echo
198 echo " $2 not found at $1 or $3 headers not found"
199 echo " Check the file $LOG for detailed error information."
200 fail
201 else
202 echo "not found."
203 echo >> $LOG
204 echo >> $LOG
205 fi
206 return 1
207 fi
208 return 0
209}
210
211# Execute a compiled test binary
212test_execute()
213{
214 echo "executing the binary" >> $LOG
215 ./.tmp_out > .test_execute.log
216 rc=$?
217 cat .test_execute.log | tee -a $LOG
218 if [ $rc -ne 0 ]; then
219 fail $1
220 return 1
221 fi
222 echo >> $LOG
223 echo >> $LOG
224 return 0
225}
226
227#
228# Check for OS, MACHINE, CPU
229#
230check_environment()
231{
232 test_header environment
233 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
234 case "$OS" in
235 linux)
236 ;;
237 darwin)
238 ;;
239 freebsd)
240 ;;
241 sunos)
242 OS='solaris'
243 ;;
244 *)
245 log_failure "Cannot determine OS"
246 exit 1
247 ;;
248 esac
249 BUILD_CPU=`uname -m`
250 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
251 case "$BUILD_CPU" in
252 i[3456789]86|x86|i86pc)
253 BUILD_MACHINE='x86'
254 LIB='lib'
255 ;;
256 x86_64|amd64)
257 BUILD_MACHINE='amd64'
258 BUILD_CPU='k8'
259 if [ "$OS" != "solaris" ]; then
260 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
261 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
262 LIB='lib64'
263 else
264 # Solaris doesn't seem to subscribe to fhs, libs are usually in
265 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
266 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
267 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
268 # have to make sure the */bin/amd64 dirs are searched before the */bin
269 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
270 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
271 echo "old PATH: $PATH" >> $LOG
272 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
273 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
274 export PATH
275 echo "new PATH: $PATH" >> $LOG
276 LIB='lib/64'
277 fi
278 ;;
279 *)
280 log_failure "Cannot determine system"
281 exit 1
282 ;;
283 esac
284 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
285 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
286 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
287 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
288 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
289 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
290
291 # Automatically disable XPCOM on darwin.
292 if [ "$OS" = "darwin" -a $WITH_XPCOM -eq 1 ]; then
293 WITH_XPCOM=0
294 WITH_LIBIDL=0
295 WITH_QT=0
296 WITH_SDL=0
297 WITH_SDL_TTF=0
298 WITH_X11=0
299 echo "Disabling checks for XPCOM related components."
300 fi
301}
302
303#
304# Check for gcc with version >= 3.2.
305# We depend on a working gcc, if we fail terminate in every case.
306#
307check_gcc()
308{
309 test_header gcc
310 if check_avail "$CC" CC really; then
311 cc_ver=`$CC -dumpversion`
312 if check_avail "$CXX" CXX really; then
313 cxx_ver=`$CXX -dumpversion`
314 cc_maj=`echo $cc_ver|cut -d. -f1`
315 cc_min=`echo $cc_ver|cut -d. -f2`
316 if [ "x$cc_ver" != "x$cxx_ver" ]; then
317 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
318 fail really
319 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 ]; then
320 if [ "$OS" = "darwin" ]; then
321 log_success "found version $cc_ver"
322 else
323 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
324 fail really
325 fi
326 elif [ $cc_maj -gt 3 ]; then
327 log_success "found version $cc_ver"
328 elif [ $cc_maj -lt 3 -o $cc_min -lt 2 ]; then
329 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
330 fail really
331 else
332 log_success "found version $cc_ver"
333 fi
334 if [ "$BUILD_MACHINE" = "amd64" ]; then
335 [ -z "$CC32" ] && CC32="$CC -m32"
336 [ -z "$CXX32" ] && CXX32="$CXX -m32"
337 else
338 [ -z "$CC32" ] && CC32="$CC"
339 [ -z "$CXX32" ] && CXX32="$CXX"
340 fi
341 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
342 [ -z "$CC64" ] && CC64="$CC -m64"
343 [ -z "$CXX64" ] && CXX64="$CXX -m64"
344 fi
345 if [ "$CC" != "gcc" ]; then
346 cnf_append "TOOL_GCC3_CC" "$CC"
347 cnf_append "TOOL_GCC3_AS" "$CC"
348 cnf_append "TOOL_GCC3_LD" "$CC"
349 cnf_append "TOOL_GXX3_CC" "$CC"
350 cnf_append "TOOL_GXX3_AS" "$CC"
351 fi
352 if [ "$CXX" != "g++" ]; then
353 cnf_append "TOOL_GCC3_CXX" "$CXX"
354 cnf_append "TOOL_GXX3_CXX" "$CXX"
355 cnf_append "TOOL_GXX3_LD" "$CXX"
356 fi
357 if [ "$CC32" != "gcc -m32" ]; then
358 cnf_append "TOOL_GCC32_CC" "$CC32"
359 cnf_append "TOOL_GCC32_AS" "$CC32"
360 cnf_append "TOOL_GCC32_LD" "$CC32"
361 cnf_append "TOOL_GXX32_CC" "$CC32"
362 cnf_append "TOOL_GXX32_AS" "$CC32"
363 fi
364 if [ "$CXX32" != "g++ -m32" ]; then
365 cnf_append "TOOL_GCC32_CXX" "$CXX32"
366 cnf_append "TOOL_GXX32_CXX" "$CXX32"
367 cnf_append "TOOL_GXX32_LD" "$CXX32"
368 fi
369 # this isn't not necessary, there is not such tool.
370 if [ -n "$CC64" ]; then
371 cnf_append "TOOL_GCC64_CC" "$CC64"
372 cnf_append "TOOL_GCC64_AS" "$CC64"
373 cnf_append "TOOL_GCC64_LD" "$CC64"
374 cnf_append "TOOL_GXX64_CC" "$CC64"
375 cnf_append "TOOL_GXX64_AS" "$CC64"
376 fi
377 if [ -n "$CXX64" ]; then
378 cnf_append "TOOL_GCC64_CXX" "$CXX64"
379 cnf_append "TOOL_GXX64_CXX" "$CXX64"
380 cnf_append "TOOL_GXX64_LD" "$CXX64"
381 fi
382 # Solaris sports a 32-bit gcc/g++.
383 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
384 [ "$CC" = "gcc" ] && CC="gcc -m64"
385 [ "$CXX" = "g++" ] && CXX="g++ -m64"
386 fi
387 fi
388 fi
389}
390
391#
392# Check for the bcc compiler, needed for compiling the BIOS
393#
394check_bcc()
395{
396 test_header bcc
397 if check_avail "$BCC" BCC; then
398 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
399 if [ $? -ne 0 ]; then
400 log_failure "not found"
401 fail
402 else
403 echo "compiling the following source file:" >> $LOG
404 cat > .tmp_src.c << EOF
405int foo(a)
406 int a;
407{
408 return 0;
409}
410EOF
411 cat .tmp_src.c >> $LOG
412 bcc_path=`which_wrapper $BCC`
413 bcc_dir="`dirname $bcc_path`/"
414 echo "using the following command line:" >> $LOG
415 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
416 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
417 if [ $? -ne 0 ]; then
418 log_failure "not found"
419 fail
420 else
421 log_success "found version $bcc_ver"
422 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
423 fi
424 unset bcc_path
425 unset bcc_dir
426 fi
427 fi
428}
429
430#
431# Check for the as86 assembler, needed for compiling the BIOS
432#
433check_as86()
434{
435 test_header as86
436 if check_avail "$AS86" AS86; then
437 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
438 if [ $? -ne 0 ]; then
439 log_failure "not found"
440 fail
441 else
442 log_success "found version $as86_ver"
443 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
444 fi
445 fi
446}
447
448#
449# Check for yasm, needed to compile assembler files
450#
451check_yasm()
452{
453 test_header yasm
454 if check_avail "$YASM" YASM; then
455 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
456 if [ $? -ne 0 ]; then
457 log_failure "not found"
458 fail
459 else
460 yasm_maj=`echo $yasm_ver|cut -d. -f1`
461 yasm_min=`echo $yasm_ver|cut -d. -f2`
462 yasm_rev=`echo $yasm_ver|cut -d. -f3`
463 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
464 if [ $yasm_ver_mul -lt 501 ]; then
465 log_failure "found version $yasm_ver, expected at least 0.5.1"
466 fail
467 else
468 log_success "found version $yasm_ver"
469 fi
470 fi
471 fi
472}
473
474#
475# Check for the iasl ACPI compiler, needed to compile vbox.dsl
476#
477check_iasl()
478{
479 test_header iasl
480 if check_avail "$IASL" IASL; then
481 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
482 if [ $? -ne 0 ]; then
483 log_failure "not found"
484 fail
485 else
486 log_success "found version $iasl_ver"
487 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
488 fi
489 fi
490}
491
492#
493# Check for xsltproc, needed by Main
494#
495check_xsltproc()
496{
497 test_header xslt
498 if check_avail "$XSLTPROC" XSLTPROC; then
499 xsltproc_ver=`$XSLTPROC --version`
500 if [ $? -ne 0 ]; then
501 log_failure "not found"
502 fail
503 else
504 log_success "found"
505 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
506 fi
507 fi
508}
509
510#
511# Check for mkisofs, needed to build the CDROM image containing the additions
512#
513check_mkisofs()
514{
515 test_header mkisofs
516 if which_wrapper $GENISOIMAGE > /dev/null; then
517 mkisofs_ver=`$GENISOIMAGE --version`
518 if [ $? -ne 0 ]; then
519 log_failure "not found"
520 fail
521 else
522 log_success "found $mkisofs_ver"
523 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
524 fi
525 elif check_avail "$MKISOFS" MKISOFS; then
526 mkisofs_ver=`$MKISOFS --version`
527 if [ $? -ne 0 ]; then
528 log_failure "not found"
529 fail
530 else
531 log_success "found $mkisofs_ver"
532 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
533 fi
534 fi
535}
536
537#
538# Check for xalan, needed by VBoxXML
539#
540check_xalan()
541{
542 if [ -n "$LIBXALAN" ]; then
543 test_header xalan
544 cat > .tmp_src.cc << EOF
545#include <cstdio>
546#include <xalanc/Include/XalanVersion.hpp>
547extern "C" int main(void)
548{
549 printf("found version %d.%d.%d",
550 XALAN_VERSION_MAJOR, XALAN_VERSION_MINOR, XALAN_VERSION_REVISION);
551#if _XALAN_VERSION >= 10800
552 printf(", OK.\n");
553 return 0;
554#else
555 printf(", expected version 1.8.0 or higher\n");
556 return 1;
557#endif
558}
559EOF
560 [ -n "$INCXALAN" ] && I_INCXALAN=`prefix_I "$INCXALAN"`
561 if test_compile "$LIBXALAN $LIBPTHREAD $I_INCXALAN" xalan xalanc; then
562 if test_execute; then
563 cnf_append "SDK_VBOX_XALAN_LIBS" "`strip_l "$LIBXALAN"`"
564 cnf_append "SDK_VBOX_XALAN_LIBPATH" "`strip_L "$LIBXALAN"`"
565 cnf_append "SDK_VBOX_XALAN_INCS" "$INCXALAN"
566 fi
567 fi
568 else
569 echo "Building xalan from shipped sources."
570 echo "Building xalan from shipped sources." >> $LOG
571 echo >> $LOG
572 echo >> $LOG
573 fi
574}
575
576#
577# Check for xerces, needed by VBoxXML
578#
579check_xerces()
580{
581 if [ -n "$LIBXERCES" ]; then
582 test_header xerces
583 cat > .tmp_src.cc << EOF
584#include <cstdio>
585#include <xercesc/util/XercesVersion.hpp>
586extern "C" int main(void)
587{
588 printf("found version %d.%d.%d",
589 XERCES_VERSION_MAJOR, XERCES_VERSION_MINOR, XERCES_VERSION_REVISION);
590#if _XERCES_VERSION >= 20500
591 printf(", OK.\n");
592 return 0;
593#else
594 printf(", expected version 2.5.0 or higher");
595 return 1;
596#endif
597}
598EOF
599 [ -n "$INCXERCES" ] && I_INCXERCES=`prefix_I "$INCXERCES"`
600 if test_compile "$LIBXERCES $LIBPTHREAD $I_INCXERCES" xerces xercesc; then
601 if test_execute; then
602 cnf_append "SDK_VBOX_XERCES_LIBS" "`strip_l "$LIBXERCES"`"
603 cnf_append "SDK_VBOX_XERCES_LIBPATH" "`strip_L "$LIBXERCES"`"
604 cnf_append "SDK_VBOX_XERCES_INCS" "$INCXERCES"
605 fi
606 fi
607 else
608 echo "Building xerces from shipped sources."
609 echo "Building xerces from shipped sources." >> $LOG
610 echo >> $LOG
611 echo >> $LOG
612 fi
613}
614
615#
616# Check for libIDL, needed by xpcom
617#
618check_libidl()
619{
620 test_header libIDL
621
622 if which_wrapper libIDL-config-2 > /dev/null; then
623 libidl_ver=`libIDL-config-2 --version`
624 if [ $? -ne 0 ]; then
625 log_failure "not found"
626 fail
627 else
628 log_success "found version $libidl_ver"
629 cnf_append "VBOX_LIBIDL_CONFIG" \
630 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
631 fi
632 elif check_avail "libIDL-config" libIDL-config; then
633 libidl_ver=`libIDL-config --version`
634 if [ $? -ne 0 ]; then
635 log_failure "not found"
636 fail
637 else
638 log_success "found version $libidl_ver"
639 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
640 fi
641 fi
642}
643
644#
645# Check for openssl, needed for RDP
646#
647check_ssl()
648{
649 test_header ssl
650 cat > .tmp_src.cc << EOF
651#include <cstdio>
652#include <openssl/opensslv.h>
653extern "C" int main(void)
654{
655 printf("found version %s", OPENSSL_VERSION_TEXT);
656#if OPENSSL_VERSION_NUMBER >= 0x0090700
657 printf(", OK.\n");
658 return 0;
659#else
660 printf(", expected version 0.9.7 or higher\n");
661 return 1;
662#endif
663}
664EOF
665 if test_compile $LIBCRYPTO libcrypto openssl; then
666 if test_execute nofatal; then
667 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
668 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
669 fi
670 fi
671}
672
673#
674# Check for pthread, needed by VBoxSVC, frontends, ...
675#
676check_pthread()
677{
678 test_header pthread
679 cat > .tmp_src.cc << EOF
680#include <cstdio>
681#include <pthread.h>
682extern "C" int main(void)
683{
684 pthread_mutex_t mutex;
685 if (pthread_mutex_init(&mutex, NULL)) {
686 printf("pthread_mutex_init() failed\n");
687 return 1;
688 }
689 if (pthread_mutex_lock(&mutex)) {
690 printf("pthread_mutex_lock() failed\n");
691 return 1;
692 }
693 if (pthread_mutex_unlock(&mutex)) {
694 printf("pthread_mutex_unlock() failed\n");
695 return 1;
696 }
697 printf("found, OK.\n");
698}
699EOF
700 if test_compile $LIBPTHREAD pthread pthread; then
701 if test_execute; then
702 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
703 fi
704 fi
705}
706
707#
708# Check for zlib, needed by VBoxSVC, Runtime, ...
709#
710check_z()
711{
712 test_header zlib
713 cat > .tmp_src.cc << EOF
714#include <cstdio>
715#include <zlib.h>
716extern "C" int main(void)
717{
718 printf("found version %s", ZLIB_VERSION);
719#if ZLIB_VERNUM >= 0x1210
720 printf(", OK.\n");
721 return 0;
722#else
723 printf(", expected version 1.2.1 or higher\n");
724 return 1;
725#endif
726}
727EOF
728 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
729 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
730 if test_execute; then
731 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
732 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
733 fi
734 fi
735}
736
737#
738# Check for libpng, needed by kchmviewer
739#
740check_png()
741{
742 test_header libpng
743 cat > .tmp_src.cc << EOF
744#include <cstdio>
745#include <png.h>
746extern "C" int main(void)
747{
748 printf("found version %s", PNG_LIBPNG_VER_STRING);
749#if PNG_LIBPNG_VER >= 10205
750 printf(", OK.\n");
751 return 0;
752#else
753 printf(", expected version 1.2.5 or higher\n");
754 return 1;
755#endif
756}
757EOF
758 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
759# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
760 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
761# if test_execute nofatal; then
762 if test_execute; then
763 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
764 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
765 fi
766 fi
767}
768
769#
770# Check for pam, needed by VRDPAuth
771# Version 79 was introduced in 9/2005, do we support older versions?
772# Debian/sarge uses 76
773# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
774#
775check_pam()
776{
777 test_header pam
778 cat > .tmp_src.cc << EOF
779#include <cstdio>
780#include <security/pam_appl.h>
781extern "C" int main(void)
782{
783 printf("found version %d", __LIBPAM_VERSION);
784 if (__LIBPAM_VERSION >= 76)
785 {
786 printf(", OK.\n");
787 return 0;
788 }
789 else
790 {
791 printf(", expected version 76 or higher\n");
792 return 1;
793 }
794}
795EOF
796 if test_compile "-lpam" pam pam nofatal; then
797 if test_execute nofatal; then
798 return 0;
799 fi
800 fi
801 test_header linux_pam
802 cat > .tmp_src.cc << EOF
803#include <cstdio>
804#include <security/pam_appl.h>
805extern "C" int main(void)
806{
807 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
808 if (__LINUX_PAM__ >= 1)
809 {
810 printf(", OK.\n");
811 return 0;
812 }
813 else
814 {
815 printf(", expected version 1.0 or higher\n");
816 return 1;
817 }
818}
819EOF
820 if test_compile "-lpam" pam pam; then
821 test_execute
822 fi
823}
824
825
826#
827# Check for the SDL library, needed by VBoxSDL and VirtualBox
828# We depend at least on version 1.2.7
829#
830check_sdl()
831{
832 test_header SDL
833 if which_wrapper sdl-config > /dev/null; then
834 FLGSDL=`sdl-config --cflags`
835 INCSDL=`strip_I "$FLGSDL"`
836 LIBSDL=`sdl-config --libs`
837 LIBSDLMAIN="-lSDLmain"
838 [ "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
839 cat > .tmp_src.cc << EOF
840#include <cstdio>
841#include <SDL/SDL.h>
842#include <SDL/SDL_main.h>
843extern "C" int main(void)
844{
845 printf("found version %d.%d.%d",
846 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
847#if SDL_VERSION_ATLEAST(1,2,7)
848 printf(", OK.\n");
849 return 0;
850#else
851 printf(", expected version 1.2.7 or higher\n");
852 return 1;
853#endif
854}
855EOF
856 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
857 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL" SDL SDL; then
858 if test_execute; then
859 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
860 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
861 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
862 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
863 fi
864 fi
865 else
866 log_failure "not found"
867 fail
868 fi
869}
870
871#
872# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
873#
874check_sdl_ttf()
875{
876 test_header SDL_ttf
877 cat > .tmp_src.cc << EOF
878#include <cstdio>
879#include <SDL/SDL_ttf.h>
880#ifndef SDL_TTF_MAJOR_VERSION
881#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
882#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
883#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
884#endif
885extern "C" int main(void)
886{
887 printf("found version %d.%d.%d",
888 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
889#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
890 printf(", OK.\n");
891 return 0;
892#else
893 printf(", expected version 2.0.6 or higher\n");
894 return 1;
895#endif
896}
897EOF
898 if test_compile "-lSDL_ttf" SDL_ttf SDL_ttf; then
899 test_execute
900 fi
901}
902
903#
904# Check for libasound, needed by the ALSA audio backend
905#
906check_alsa()
907{
908 test_header ALSA
909 cat > .tmp_src.cc << EOF
910#include <alsa/asoundlib.h>
911extern "C" int main(void)
912{
913 printf("found version %d.%d.%d",
914 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
915#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
916 printf(", OK.\n");
917 return 0;
918#else
919 printf(", expected version 1.0.6 or higher\n");
920 return 1;
921#endif
922}
923EOF
924 if test_compile "-lasound" asound asound; then
925 test_execute
926 fi
927}
928
929#
930# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
931#
932check_xcursor()
933{
934 test_header Xcursor
935 cat > .tmp_src.cc << EOF
936#include <cstdio>
937#include <X11/Xlib.h>
938#include <X11/Xcursor/Xcursor.h>
939extern "C" int main(void)
940{
941 XcursorImage *cursor = XcursorImageCreate (10, 10);
942 XcursorImageDestroy(cursor);
943 return 0;
944}
945EOF
946 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
947 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
948 log_success "found"
949 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
950 fi
951}
952
953#
954# Check for the X libraries (Xext, X11)
955#
956check_x()
957{
958 test_header "X libraries"
959 cat > .tmp_src.cc << EOF
960#include <cstdio>
961#include <X11/Xlib.h>
962extern "C" int main(void)
963{
964 Display *dpy;
965 int scrn_num;
966 Screen *scrn;
967 Window win;
968
969 dpy = XOpenDisplay(NULL);
970 scrn_num = DefaultScreen(dpy);
971 scrn = ScreenOfDisplay(dpy, scrn_num);
972 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
973 0, 16, InputOutput, CopyFromParent, 0, NULL);
974 XDestroyWindow(dpy, win);
975}
976EOF
977 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
978 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
979 log_success "found"
980 fi
981}
982
983#
984# Check for the QT library, needed by VirtualBox
985#
986check_qt()
987{
988 test_header Qt
989 cat > .tmp_src.cc << EOF
990#include <cstdio>
991#include <qglobal.h>
992extern "C" int main(void)
993{
994 printf("found version %s", QT_VERSION_STR);
995#if QT_VERSION >= 0x030305
996 printf(", OK.\n");
997 return 0;
998#elif QT_VERSION >= 0x030300
999 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
1000#else
1001 printf(", expected version 3.3.0 or higher\n");
1002 return 1;
1003#endif
1004}
1005EOF
1006 found_qt=0
1007 libs="lib"
1008 [ "$LIB" = "lib64" ] && libs="$libs lib64"
1009 for q in $QTDIR; do
1010 for l in $libs; do
1011 echo "compiling the following source file:" >> $LOG
1012 cat .tmp_src.cc >> $LOG
1013 echo "using the following command line:" >> $LOG
1014 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD" >> $LOG
1015 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD >> $LOG 2>&1
1016 if [ $? -eq 0 ]; then
1017 if test_execute; then
1018 cnf_append "QTDIR" "`cd $q ; pwd`"
1019 found_qt=1
1020 break
1021 fi
1022 fi
1023 done
1024 if [ $found_qt -eq 1 ]; then
1025 break
1026 fi
1027 done
1028 if [ $found_qt -ne 1 ]; then
1029 echo
1030 echo " Qt not found at \"$QTDIR\" or Qt headers not found"
1031 echo " Check the file $LOG for detailed error information."
1032 fail
1033 return 1
1034 fi
1035 test_header "Qt devtools"
1036 if check_avail "$q/bin/moc" QTDIR/bin; then
1037 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
1038 if [ $? -ne 0 ]; then
1039 log_failure "not found"
1040 fail
1041 else
1042 log_success "found version $moc_ver"
1043 fi
1044 fi
1045}
1046
1047#
1048# Check whether static libstdc++ is installed
1049#
1050check_staticlibstdcxx()
1051{
1052 test_header "static stc++ library"
1053 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1054 cat > .tmp_src.cc << EOF
1055#include <string>
1056
1057extern "C" int main(void)
1058{
1059 std::string s = "test";
1060 return 0;
1061}
1062EOF
1063 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1064 log_success "found"
1065 fi
1066}
1067
1068#
1069# Check for Linux sources
1070#
1071check_linux()
1072{
1073 test_header "Linux kernel sources"
1074 cat > .tmp_src.c << EOF
1075#include <linux/version.h>
1076int printf(const char *format, ...);
1077int main(void)
1078{
1079 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1080 (LINUX_VERSION_CODE % 65536) / 256,
1081 LINUX_VERSION_CODE % 256);
1082#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1083 printf(", OK.\n");
1084 return 0;
1085#else
1086 printf(", expected version 2.4.0 or higher\n");
1087 return 1;
1088#endif
1089}
1090EOF
1091 echo "compiling the following source file:" >> $LOG
1092 cat .tmp_src.c >> $LOG
1093 echo "using the following command line:" >> $LOG
1094 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1095 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1096 if [ $? -ne 0 ]; then
1097 echo
1098 echo " Linux kernel headers not found at $LINUX"
1099 echo " Check the file $LOG for detailed error information."
1100 fail
1101 else
1102 if test_execute; then
1103 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1104 fi
1105 fi
1106}
1107
1108#
1109# Check for kchmviewer, needed to display the online help
1110#
1111check_kchmviewer()
1112{
1113 test_header kchmviewer
1114 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1115 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1116 if [ $? -ne 0 ]; then
1117 log_failure "not found"
1118 fail
1119 else
1120 log_success "found version $kchmviewer_ver"
1121 fi
1122 fi
1123}
1124
1125#
1126# Check for the kBuild tools, we don't support GNU make
1127#
1128check_kbuild()
1129{
1130 test_header kBuild
1131 if check_avail "$KBUILDDIR_BIN/kmk" KBUILDDIR really; then
1132 log_success "found"
1133 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
1134 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
1135 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
1136 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
1137 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
1138 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
1139 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1140 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1141 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1142 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1143 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1144 if [ "$OS" = "solaris" ]; then
1145 # Because of sh being non-default shell in Solaris we need to export PATH again when
1146 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1147 echo "PATH=\"$ORGPATH\"" >> $ENV
1148 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1149 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1150 else
1151 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1152 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1153 fi
1154 echo "export PATH" >> $ENV
1155 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1156 fi
1157}
1158
1159
1160#
1161# Check for compiler.h
1162# Some Linux distributions include "compiler.h" in their libc linux
1163# headers package, some don't. Most don't need it, building might (!)
1164# not succeed on openSUSE without it.
1165#
1166# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1167#
1168check_compiler_h()
1169{
1170 test_header compiler.h
1171 if ! test -f "/usr/include/linux/compiler.h"; then
1172 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1173 log_success "compiler.h not found"
1174 else
1175 log_success "compiler.h found"
1176 fi
1177}
1178
1179
1180#
1181# Check if we are able to build 32-bit applications (needed for the guest additions)
1182#
1183check_32bit()
1184{
1185 test_header "32-bit support"
1186 cat > .tmp_src.c << EOF
1187#include <stdint.h>
1188int main(void)
1189{
1190 return 0;
1191}
1192EOF
1193 echo "compiling the following source file:" >> $LOG
1194 cat .tmp_src.c >> $LOG
1195 echo "using the following command line:" >> $LOG
1196 echo "$CC -m32 -O -Wall -o .tmp_out .tmp_src.c" >> $LOG
1197 $CC -m32 -O -Wall -o .tmp_out .tmp_src.c >> $LOG 2>&1
1198 if [ $? -ne 0 ]; then
1199 echo
1200 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1201 echo " Check the file $LOG for detailed error information."
1202 fail
1203 fi
1204 log_success ""
1205}
1206
1207#
1208# Setup wine
1209#
1210setup_wine()
1211{
1212 test_header "Wine support"
1213 if ! which_wrapper wine > /dev/null; then
1214 echo " wine binary not found"
1215 fail
1216 fi
1217 if ! which_wrapper wineprefixcreate > /dev/null; then
1218 echo " wineprefixcreate not found"
1219 fail
1220 fi
1221 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1222 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1223 rm -rf $WINEPREFIX
1224 mkdir -p $WINEPREFIX
1225 touch $WINEPREFIX/.no_prelaunch_window_flag
1226 if ! wineprefixcreate -q > /dev/null 2>&1; then
1227 echo " wineprefixcreate failed"
1228 fail
1229 fi
1230 tmp=.tmp.wine.reg
1231 rm -f $tmp
1232 echo 'REGEDIT4' > $tmp
1233 echo '' >> $tmp
1234 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1235 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1236 echo '' >> $tmp
1237 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1238 echo '"itss"="native"' >> $tmp
1239 echo '' >> $tmp
1240 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1241 echo '"itss"="native"' >> $tmp
1242 echo '' >> $tmp
1243 if ! wine regedit $tmp > /dev/null 2>&1; then
1244 rm -f $tmp
1245 echo " failed to load registry changes (path)."
1246 fail
1247 fi
1248 rm -f $tmp
1249 log_success "found"
1250}
1251
1252
1253#
1254# Show help
1255#
1256show_help()
1257{
1258 cat << EOF
1259Usage: ./configure [OPTIONS]...
1260
1261Configuration:
1262 -h, --help display this help and exit
1263 --nofatal don't abort on errors
1264 --disable-xpcom disable XPCOM and related stuff
1265 --disable-sdl-ttf disable SDL_ttf detection
1266 --build-xalan build xalan & xerces from shipped sources
1267 --setup-wine setup a Wine directory and register the hhc hack
1268
1269Paths:
1270 --with-gcc=PATH location of the gcc compiler [$CC]
1271 --with-g++=PATH location of the g++ compiler [$CXX]
1272 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1273 --with-iasl=PATH location of the iasl compiler [$IASL]
1274 --with-linux=DIR Linux kernel source directory [$LINUX]
1275 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1276 --with-qt-dir=DIR directory for QT headers/libraries [$QTDIR]
1277 --with-xalan=LIB location of the xalan library [$LIBXALAN]
1278 --with-xalan-incdir=DIR location of the xalan headers [/usr/include /usr/local/include]
1279 --with-xalan-libdir=DIR location of the xalan library [/usr/lib /usr/local/lib]
1280 --with-xerces=LIB location of the xerces library [$LIBXERCES]
1281 --with-xerces-incdir=DIR location of the xerces headers [/usr/include /usr/local/include]
1282 --with-xerces-libdir=DIR location of the xerces library [/usr/lib /usr/local/lib]
1283
1284Build type:
1285 -d, --build-debug build with debugging symbols and assertions
1286 --build-headless build headless (without any X11 frontend)
1287EOF
1288 exit 0
1289}
1290
1291
1292#
1293# The body.
1294#
1295
1296# scan command line options
1297for option in $*; do
1298 case "$option" in
1299 --help|-help|-h)
1300 show_help
1301 ;;
1302 --nofatal)
1303 nofatal=1
1304 ;;
1305 --with-gcc=*)
1306 CC=`echo $option | cut -d'=' -f2`
1307 ;;
1308 --with-g++=*)
1309 CXX=`echo $option | cut -d'=' -f2`
1310 ;;
1311 --with-kbuild=*)
1312 KBUILDDIR=`echo $option | cut -d'=' -f2`
1313 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1314 echo "Error: KBUILDDIR contains invalid characters!"
1315 exit 1
1316 fi
1317 ;;
1318 --with-qt-dir=*)
1319 QTDIR=`echo $option | cut -d'=' -f2`
1320 ;;
1321 --with-iasl=*)
1322 IASL=`echo $option | cut -d'=' -f2`
1323 ;;
1324 --with-linux=*)
1325 LINUX=`echo $option | cut -d'=' -f2`
1326 ;;
1327 --with-mkisofs=*)
1328 MKISOFS=`echo $option | cut -d'=' -f2`
1329 ;;
1330 --with-xalan=*)
1331 LIBXALAN=`echo $option | cut -d'=' -f2`
1332 ;;
1333 --with-xalan-libdir=*)
1334 LIBXALAN_DIR=`echo $option | cut -d'=' -f2`
1335 ;;
1336 --with-xalan-incdir=*)
1337 INCXALAN=`echo $option | cut -d'=' -f2`
1338 ;;
1339 --with-xerces=*)
1340 LIBXERCES=`echo $option | cut -d'=' -f2`
1341 ;;
1342 --with-xerces-libdir=*)
1343 LIBXERCES_DIR=`echo $option | cut -d'=' -f2`
1344 ;;
1345 --with-xerces-incdir=*)
1346 INCXERCES=`echo $option | cut -d'=' -f2`
1347 ;;
1348 --disable-xpcom)
1349 WITH_XPCOM=0
1350 ;;
1351 --disable-sdl-ttf)
1352 WITH_SDL_TTF=0
1353 ;;
1354 --disable-qt)
1355 WITH_QT=0
1356 ;;
1357 --build-debug|-d)
1358 BUILD_TYPE=debug
1359 ;;
1360 --build-xalan)
1361 LIBXERCES=
1362 LIBXERCES_DIR=
1363 LIBXALAN=
1364 LIBXALAN_DIR=
1365 ;;
1366 --build-headless)
1367 HEADLESS=1
1368 WITH_SDL=0
1369 WITH_SDL_TTF=0
1370 WITH_X11=0
1371 WITH_QT=0
1372 ;;
1373 --ose)
1374 OSE=2
1375 ;;
1376 --odir=*)
1377 ODIR="`echo $option | cut -d'=' -f2`/"
1378 ;;
1379 --setup-wine)
1380 SETUP_WINE=1
1381 ;;
1382 *)
1383 echo
1384 echo "Unrecognized option \"$option\""
1385 echo
1386 show_help
1387 ;;
1388 esac
1389done
1390
1391[ -n "$LIBXALAN_DIR" ] && LIBXALAN="-L$LIBXALAN_DIR $LIBXALAN"
1392[ -n "$LIBXERCES_DIR" ] && LIBXERCES="-L$LIBXERCES_DIR $LIBXERCES"
1393
1394LOG="$ODIR$LOG"
1395ENV="$ODIR$ENV"
1396CNF="$ODIR$CNF"
1397
1398# initialize output files
1399cat > $LOG << EOF
1400# Log file generated by
1401#
1402# '$0 $*'
1403#
1404
1405EOF
1406cat > $CNF << EOF
1407# -*- Makefile -*-
1408#
1409# automatically generated by
1410#
1411# '$0 $*'
1412#
1413# It will be completely overwritten if configure is executed again.
1414#
1415
1416EOF
1417cat > $ENV << EOF
1418#!/bin/bash
1419#
1420# automatically generated by
1421#
1422# '$0 $*'
1423#
1424# It will be completely overwritten if configure is executed again.
1425# Make sure you source this file once before you start to build VBox.
1426#
1427
1428EOF
1429
1430# test if we are OSE
1431if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
1432 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1433 echo >> $LOG
1434 OSE=0
1435fi
1436
1437if [ "$BUILD_TYPE" = "debug" ]; then
1438 echo "Creating DEBUG build!" >> $LOG
1439fi
1440
1441# first determine our environment
1442check_environment
1443check_kbuild
1444
1445# append the tools directory to the default search path
1446echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1447export PATH
1448
1449# some things are not available in for OSE
1450if [ $OSE -ge 1 ]; then
1451 cnf_append "VBOX_OSE" "1"
1452 cnf_append "VBOX_WITH_TESTSUITE" ""
1453 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
1454
1455 if [ "$OS" = "linux" ]; then
1456 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
1457 else
1458 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
1459 fi
1460 echo >> $CNF
1461fi
1462
1463# headless
1464if [ -n "$HEADLESS" ]; then
1465 cnf_append "VBOX_HEADLESS" "1"
1466fi
1467
1468# emit disable directives corresponding to any --disable-xxx options.
1469[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
1470[ $WITH_QT -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
1471[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
1472
1473# the tools
1474check_gcc
1475[ "$OS" != "darwin" ] && check_as86
1476[ "$OS" != "darwin" ] && check_bcc
1477[ "$OS" != "darwin" ] && check_iasl
1478# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
1479# [ "$OS" != "darwin" ] && check_yasm
1480[ "$OS" != "darwin" ] && check_xsltproc
1481[ $OSE -eq 0 ] && check_mkisofs
1482
1483# the libraries
1484[ "$OS" != "darwin" ] && check_pthread
1485[ $WITH_XPCOM -eq 1 ] && check_xalan
1486[ $WITH_XPCOM -eq 1 ] && check_xerces
1487[ $WITH_LIBIDL -eq 1 ] && check_libidl
1488[ $OSE -eq 0 ] && check_ssl
1489[ "$OS" != "darwin" ] && check_z
1490[ $OSE -eq 0 ] && check_png
1491[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
1492[ $WITH_SDL -eq 1 ] && check_sdl
1493[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
1494[ $WITH_X11 -eq 1 ] && check_x
1495[ $WITH_X11 -eq 1 ] && check_xcursor
1496[ $WITH_QT -eq 1 ] && check_qt
1497
1498# Linux-specific
1499if [ "$OS" = "linux" ]; then
1500 check_staticlibstdcxx
1501 check_linux
1502 check_alsa
1503 check_compiler_h
1504 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
1505fi
1506
1507[ -n "$SETUP_WINE" ] && setup_wine
1508
1509# success!
1510echo
1511echo "Successfully generated '$CNF' and '$ENV'."
1512echo "Source '$ENV' once before you start to build VBox:"
1513echo ""
1514echo " source $ENV"
1515echo " kmk"
1516echo ""
1517if [ "$OS" = "linux" ]; then
1518 echo "To compile the kernel module, do:"
1519 echo ""
1520 echo " cd ./out/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
1521 echo " make"
1522 echo ""
1523fi
1524echo "Enjoy!"
1525cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette